---
page_source: https://juspay.io/in/docs/api-reference/docs/express-checkout/outages-guide
page_title: Outages Guide
---


# Outages guide




## Background



Payment systems are complex, typically involving multiple systems such as issuing bank, network, payment orchestrator, payment aggregator, payment gateway, and acquiring bank. Any of these systems facing outage leads to payment failure. Many of these systems are maturing and we see frequent outages.

Detecting an outage is not an easy task given the parties involved. Not many systems provide a ping API to check the health of a system. We have tried different models and adopted payment failure based outage detection.

![Image](https://dth95m2xtyv8v.cloudfront.net/tesseract/assets/api-reference/895660e-outage.png)




## Working of Outage API



The algorithm constantly monitors and learns the payment failures for each payment method. Outage systems maintain the score for each payment method in 0 to 1 range and with two stages: FLUCTUATE and DOWN.

When any particular payment method sees a high number of failures back-to-back and it crosses FLUCTUATE threshold, outage API starts showing that payment method with FLUCTUATE, and when it crosses DOWN threshold , outage API starts showing that payment method with DOWN.

Outage system keeps score at global level (across merchants) to consider high number of failures at global level and make outage decisions. This helps when at merchant level, we don’t have enough transactions to make an outage decision.


## Features



Global information - across merchantsGranular - detects bank-wise outagesTwo stage outage - Fluctuate, DownNear real-time - detects outages as early as it happens and accuratelyConfigurable - you can define fluctuate threshold and down threshold based on your business needs**Levels at which outages are tracked** :1. CARD - At Card Network <> Bank Level2. Net Banking - At Bank level3. Wallet - At Wallet level4. UPI -   a. At Transaction type level - UPI COLLECT, UPI PAY, UPI INAPP   b. At vpa handle level (for UPI COLLECT) and at app level for (UPI PAY)   c. At Issuing bank level & NPCI level - This is a premium feature and requires additional enablement at Juspay level**How to access outage response** :In _/paymentmethods_  API call, set _options.add_outage_ to true. If any outages are present in the payment ecosystem, the information will be shown to the merchant in the outage block of the API responseFor issuing bank & NPCI level outages for UPI, post enablement at Juspay level, set _options.add_upi_outages_ to true in the _/paymentmethods_  API call. If any outages are present in the issuing bank level or NPCI level for UPI payments, the outage information will be shown to the merchant as part of the outage block of the API response

**How to access outage information** In the /paymentmethods API call set _options.add_outage_ flag to true. If outages are present it will be shown to the merchant in the outage block of the API responseTo recieve issuing bank level & NPCI level information for UPI, the options.add_upi_outages in the /paymentmethods call needs to be set to true (post enablement at Juspay for this feature)

## Sample Code Snippets:
### Sample request:

#### Request Code Snippet:

```request
curl -X GET https://api.juspay.in/merchants/guest/paymentmethods?options.add_outage=true
curl -X GET https://api.juspay.in/merchants/guest/paymentmethods?options.add_outage=true&options.add_upi_outages=true

```

### Sample Response:

#### Outage response block:
```json
"outage": [
    {
      "stage": "Merchant",
      "status": "FLUCTUATE",
      "payment_method": "RUPAY",
      "payment_method_type": "CARD",
      "issuer_name": "Bank of Baroda",
      "juspay_bank_code": "JP_BOB",
      "description": "Rupay"
    },
    {
      "stage": "Global",
      "status": "FLUCTUATE",
      "payment_method": "NB_UBI",
      "payment_method_type": "NB",
      "issuer_name": "Union Bank of India",
      "juspay_bank_code": "JP_UBI",
      "description": "Union Bank of India"
    },
    {
      "stage": "Global",
      "status": "FLUCTUATE",
      "payment_method": "FREECHARGE",
      "payment_method_type": "WALLET",
      "issuer_name": "Freecharge",
      "juspay_bank_code": "JP_FREECHARGE",
      "description": "Freecharge Wallet"
    },
    {
      "stage": "Merchant",
      "status": "DOWN",
      "payment_method": "UPI",
      "payment_method_type": "UPI",
      "txn_type": "UPI_COLLECT",
      "description": "Pay with UPI",
      "sub_details": [
        {
          "stage": "Merchant",
          "status": "DOWN",
          "upi_handle": "okhdfcbank"
        },
        {
          "stage": "Merchant",
          "status": "DOWN",
          "upi_handle": "okaxis"
        },
        {
          "stage": "Merchant",
          "status": "DOWN",
          "upi_handle": "upi"
        },
        {
          "stage": "Merchant",
          "status": "DOWN",
          "upi_handle": "axl"
        }
      ]
    },
    {
      "stage": "Global",
      "status": "DOWN",
      "payment_method": "UPI",
      "payment_method_type": "UPI",
      "txn_type": "UPI_PAY",
      "description": "Pay with UPI",
      "sub_details": [
        {
          "stage": "Global",
          "status": "FLUCTUATE",
          "upi_app": "com.phonepe.app"
        },
        {
          "stage": "Global",
          "status": "FLUCTUATE",
          "upi_app": "net.one97.paytm"
        }
      ]
    },
    {
      "stage": "Global",
      "status": "FLUCTUATE",
      "payment_method": "UPI",
      "payment_method_type": "UPI",
      "txn_type": "UPI_INAPP",
      "description": "Pay with UPI",
      "sub_details": [
        {
          "stage": "Global",
          "status": "DOWN",
          "upi_app": "com.phonepe.app"
        },
        {
          "stage": "Global",
          "status": "FLUCTUATE",
          "upi_app": "net.one97.paytm"
        }
      ]
    }
  ]
}

```

#### Outage block with UPI Issuing bank & NPCI level outage:
```json
"outage": [
    {
      "stage": "Merchant",
      "status": "FLUCTUATE",
      "payment_method": "RUPAY",
      "payment_method_type": "CARD",
      "issuer_name": "Bank of Baroda",
      "juspay_bank_code": "JP_BOB",
      "description": "Rupay"
    },
    {
      "stage": "Global",
      "status": "FLUCTUATE",
      "payment_method": "NB_UBI",
      "payment_method_type": "NB",
      "issuer_name": "Union Bank of India",
      "juspay_bank_code": "JP_UBI",
      "description": "Union Bank of India"
    },
    {
      "stage": "Global",
      "status": "FLUCTUATE",
      "payment_method": "FREECHARGE",
      "payment_method_type": "WALLET",
      "issuer_name": "Freecharge",
      "juspay_bank_code": "JP_FREECHARGE",
      "description": "Freecharge Wallet"
    },
    {
      "stage": "Merchant",
      "status": "DOWN",
      "payment_method": "UPI",
      "payment_method_type": "UPI",
      "txn_type": "UPI_COLLECT",
      "description": "Pay with UPI",
      "sub_details": [
        {
          "stage": "Merchant",
          "status": "DOWN",
          "upi_handle": "okhdfcbank"
        },
        {
          "stage": "Merchant",
          "status": "DOWN",
          "upi_handle": "okaxis"
        },
        {
          "stage": "Merchant",
          "status": "DOWN",
          "upi_handle": "upi"
        },
        {
          "stage": "Merchant",
          "status": "DOWN",
          "upi_handle": "axl"
        }
      ]
    },
    {
      "stage": "Global",
      "status": "DOWN",
      "payment_method": "UPI",
      "payment_method_type": "UPI",
      "txn_type": "UPI_PAY",
      "description": "Pay with UPI",
      "sub_details": [
        {
          "stage": "Global",
          "status": "FLUCTUATE",
          "upi_app": "com.phonepe.app"
        },
        {
          "stage": "Global",
          "status": "FLUCTUATE",
          "upi_app": "net.one97.paytm"
        }
      ]
    },
    {
      "stage": "Global",
      "status": "FLUCTUATE",
      "payment_method": "UPI",
      "payment_method_type": "UPI",
      "txn_type": "UPI_INAPP",
      "description": "Pay with UPI",
      "sub_details": [
        {
          "stage": "Global",
          "status": "DOWN",
          "upi_app": "com.phonepe.app"
        },
        {
          "stage": "Global",
          "status": "FLUCTUATE",
          "upi_app": "net.one97.paytm"
        }
      ]
    },
    {
      "status": "DOWN",
      "payment_method": "UPI",
      "payment_method_type": "UPI",
      "issuer_name": "STATE BANK OF INDIA",
      "juspay_bank_code": "JP_SBI",
      "description": "UPI Transactions"
    },
    { 
      "status": "DOWN", 
      "payment_method": "UPI", 
      "payment_method_type": "UPI", 
      "issuer_name": "NPCI", 
      "juspay_bank_code": "JP_UPI", 
      "description": "UPI Transactions" 
     }
  ]
}

```

